package observer;

import java.util.Observable;
import java.util.Observer;

public class Flower {
	private boolean _isOpen;
	private OpenNotifier oNotify = new OpenNotifier(this);
	private CloseNotifier cNotify = new CloseNotifier();

	public Flower() {
		_isOpen = false;
	}
	//private
	boolean isOpen() {
		return _isOpen;
	}
	private void setIsOpen(boolean newValue) {
		_isOpen = newValue;
	}
	public void open() { // Opens its petals
		System.out.println("Flower open.");
		setIsOpen(true);
		oNotify.notifyObservers();
		cNotify.open();
	}
	public void close() { // Closes its petals
		System.out.println("Flower close.");
		setIsOpen(false);
		cNotify.notifyObservers();
		oNotify.close();
	}
	public Observable opening() {
		return oNotify;
	}
	public Observable closing() {
		return cNotify;
	}
//	private class OpenNotifier extends Observable {
//		private Flower _enclosing;
//		private boolean alreadyOpen = false;
//		public OpenNotifier(Flower flower) {
//			_enclosing = flower;
//		}
//		public void notifyObservers() {
//			if(_enclosing.isOpen() && !this.alreadyOpen) {
//				this.setChanged();
//				super.notifyObservers();
//				this.alreadyOpen = true;
//			}
//		}
//		public void close() {
//			this.alreadyOpen = false;
//		}
//	}
	private class CloseNotifier extends Observable {
		private boolean alreadyClosed = false;
		public void notifyObservers() {
			if(!isOpen() && !alreadyClosed) {
				setChanged();
				super.notifyObservers();
				alreadyClosed = true;
			}
		}
		public void open() {
			alreadyClosed = false;
		}
	}
}
