package observer;

import java.util.*;

public class Bee implements BreakfastTaker {
	private String name;
	private OpenObserver openObsrv = new OpenObserver(this);
	private CloseObserver closeObsrv = new CloseObserver();

	public Bee(String nm) {
		name = nm;
	}
	public void breakfastTime() {
		System.out.println("Bee " + name + "'s breakfast time!");
	}
	// An inner class for observing openings:
//	private class OpenObserver implements Observer {
//		private BreakfastTaker _enclosing;
//		public OpenObserver(BreakfastTaker enclosing) {
//			_enclosing = enclosing;
//		}
//		public void update(Observable ob, Object a) {
//			_enclosing.breakfastTime();
//		}
//	}
	// Another inner class for closings:
	private class CloseObserver implements Observer{
		public void update(Observable ob, Object a) {
			System.out.println(
				"Bee " + name + "'s bed time!");
		}
	}
	public Observer openObserver() { 
		return openObsrv; 
	}
	public Observer closeObserver() { 
		return closeObsrv;
	}
}
