package observer;

import java.util.*;

public class Hummingbird implements BreakfastTaker {
	private String name;
	private OpenObserver openObsrv = new OpenObserver(this);
	private CloseObserver closeObsrv = new CloseObserver();

	public Hummingbird(String nm) {
		name = nm;
	}
	public void breakfastTime() {
		System.out.println("Hummingbird " + name + "'s breakfast time!");
	}
//	private class OpenObserver implements Observer{
//		private BreakfastTaker _enclosing;
//		public OpenObserver(BreakfastTaker enclosing) {
//			_enclosing = enclosing;
//		}
//		public void update(Observable ob, Object a) {
//			_enclosing.breakfastTime();
//		}
//	}
	private class CloseObserver implements Observer{
		public void update(Observable ob, Object a) {
			System.out.println(
				"Hummingbird " + name + "'s bed time!");
		}
	}
	public Observer openObserver() { 
		return openObsrv; 
	}
	public Observer closeObserver() { 
		return closeObsrv;
	}
}
