package observer;

import java.util.*;

public class Bee implements BreakfastTaker {
	private String name;
	private OpenObserver openObsrv = new OpenObserver(this);
	private CloseObserver closeObsrv = new CloseObserver();

	public Bee(String nm) {
		name = nm;
	}
	public void breakfastTime() {
		System.out.println("Bee " + name + "'s breakfast time!");
	}
	// Another inner class for closings:
	private class CloseObserver implements Observer{
		public void update(Observable ob, Object a) {
			System.out.println(
				"Bee " + name + "'s bed time!");
		}
	}
	public Observer openObserver() { 
		return openObsrv; 
	}
	public Observer closeObserver() { 
		return closeObsrv;
	}
}
