/*
 * Created on 11/Mai/2004
 */
package observer;

import java.util.Observable;
/**
 * @author Miguel Pessoa Monteiro
 */
public aspect ObservingOpen {
	private OpenNotifier Flower.oNotify = new OpenNotifier(this);
	public Observable Flower.opening() {
		return oNotify;
	}
	pointcut flowerOpen(Flower flower):
		execution(void open()) && this(flower);
	after(Flower flower) returning : flowerOpen(flower) {
		flower.oNotify.notifyObservers();
	}
	pointcut flowerClose(Flower flower):
		execution(void close()) && this(flower);
	after(Flower flower): flowerClose(flower) {
		flower.oNotify.close();
	}
}
