/*
 * Created on 13/Mai/2004
 */
package observer;

import java.util.Observable;

/**
 * @author Miguel Pessoa Monteiro
 */
public class CloseNotifier extends Observable {
	private Flower _enclosing;
	public CloseNotifier(Flower flower) {
		_enclosing = flower;
	}
	private boolean alreadyClosed = false;
	public void notifyObservers() {
		if(!_enclosing.isOpen() && !this.alreadyClosed) {
			this.setChanged();
			super.notifyObservers();
			this.alreadyClosed = true;
		}
	}
	public void open() {
		this.alreadyClosed = false;
	}
}
