package observer;

//import java.util.Observable;
//import java.util.Observer;

public aspect ObservingOpen {
	private interface Subject {}
	private interface Observer {}
	declare parents: Flower implements Subject;

	public abstract boolean Subject.isOpen();

	private interface BreakfastTaker {
		public void breakfastTime();
	}
	declare parents: (Bee || Hummingbird) implements BreakfastTaker;

	static class OpenNotifier extends java.util.Observable {
		private Subject _enclosing;
		private boolean alreadyOpen = false;
		public OpenNotifier(Subject flower) {
			_enclosing = flower;
		}
		public void notifyObservers() {
			if(_enclosing.isOpen() && !this.alreadyOpen) {
				this.setChanged();
				super.notifyObservers();
				this.alreadyOpen = true;
			}
		}
		public void close() {
			this.alreadyOpen = false;
		}
	}
	static class OpenObserver implements java.util.Observer {
		private BreakfastTaker _enclosing;
		public OpenObserver(BreakfastTaker enclosing) {
			_enclosing = enclosing;
		}
		public void update(java.util.Observable ob, Object a) {
			_enclosing.breakfastTime();
		}
	}
	private	OpenNotifier Subject.oNotify = new OpenNotifier(this);
	private OpenObserver Hummingbird.openObsrv = new OpenObserver(this);
	private OpenObserver Bee.openObsrv = new OpenObserver(this);

	public java.util.Observable Subject.opening() {
		return oNotify;
	}
	pointcut flowerOpen(Subject /*Flower*/ flower):
		execution(void open()) && this(flower);
	after(Subject /*Flower*/ flower) returning : flowerOpen(flower) {
		flower.oNotify.notifyObservers();
	}
	pointcut flowerClose(Subject /*Flower*/ flower):
		execution(void close()) && this(flower);
	after(Subject /*Flower*/ flower): flowerClose(flower) {
		flower.oNotify.close();
	}

	public java.util.Observer Bee.openObserver() { 
		return openObsrv; 
	}
	public java.util.Observer Hummingbird.openObserver() { 
		return openObsrv;
	}
}