package observer;

import java.util.*;
import junit.framework.*;
import util.*;

public class TestObservedFlower extends TestCase {
	private static String expectedOutput() {
		return 
		"Flower open.\n" +
		"Hummingbird X's breakfast time!\n" +
		"Bee B's breakfast time!\n" +
		"Bee A's breakfast time!\n" +
		"Flower open.\n" +
		"Flower close.\n" +
		"Hummingbird Y's bed time!\n" +
		"Hummingbird X's bed time!\n" +
		"Bee B's bed time!\n" +
		"Flower close.\n" +
		"Flower open.\n" +
		"Flower close.\n" +
		"Hummingbird Y's bed time!\n" +
		"Hummingbird X's bed time!\n" +
		"Bee B's bed time!\n";
	}
	Flower f = new Flower();
	Bee ba = new Bee("A"), 
		bb = new Bee("B");
	Hummingbird
		hx = new Hummingbird("X"), 
		hy = new Hummingbird("Y");
	public void test() {
//		ObservingOpen.aspectOf().addObserver(f, ba);
//		ObservingOpen.aspectOf().addObserver(f, bb);
//		ObservingOpen.aspectOf().addObserver(f, hx);
//		ObservingOpen.aspectOf().addObserver(f, hy);
		f.opening().addObserver(ba.openObserver());
		f.opening().addObserver(bb.openObserver());
		f.opening().addObserver(hx.openObserver());
		f.opening().addObserver(hy.openObserver());

		f.closing().addObserver(ba.closeObserver());
		f.closing().addObserver(bb.closeObserver());
		f.closing().addObserver(hx.closeObserver());
		f.closing().addObserver(hy.closeObserver());
		// Hummingbird Y decides to sleep in:
		f.opening().deleteObserver(hy.openObserver());
//		ObservingOpen.aspectOf().removeObserver(f, hy);

		// A change that interests observers:
		f.open();
		f.open(); // It's already open, no change.
		// Bee A doesn't want to go to bed:
		f.closing().deleteObserver(ba.closeObserver());
		f.close();
		f.close(); // It's already closed; no change
//		ObservingOpen.aspectOf().clearObservers(f);
		f.opening().deleteObservers();

		f.open();
		f.close();
		Assert.assertEquals(expectedOutput(), SpecificOutputCapture.getResult());
	}
	/**This inner aspect supresses output from objects within this package
	 * when they do NOT originate from within the control flow of main()    */
	private static aspect SpecificOutputSuppress extends OutputSupress {
		protected pointcut scopeException():
			cflow(execution(
				public static void TestObservedFlower*.main(String[])
				));
	}
	private static aspect SpecificOutputCapture extends OutputCapture {
		declare precedence:
			TestObservedFlower.SpecificOutputCapture,
			TestObservedFlower.SpecificOutputSuppress;
		public pointcut printScope():
			!within(TestObservedFlower.SpecificOutputCapture);
	}
	public static void main(String args[]) {
		junit.textui.TestRunner.run(TestObservedFlower.class);
	}
} ///:~
