package observer;

import java.util.WeakHashMap;
import java.util.List;
import java.util.ArrayList;
import java.util.ListIterator;

public aspect ObservingOpen extends ObservingRelationships {
	public abstract boolean Subject.isOpen();
	public abstract void Observer.breakfastTime();
	private boolean Subject.alreadyOpen = false;

	protected void notifyObservers(Subject subject) {
		if(subject.isOpen() && !subject.alreadyOpen) {
			subject.alreadyOpen = true;
			List observers = getObservers(subject);
			for(ListIterator it = observers.listIterator(); it.hasNext();) {
				((Observer)it.next()).breakfastTime();
			}
		}
	}
	private pointcut flowerOpen(Subject subject):
		execution(void open()) && this(subject);
	after(Subject subject) returning : flowerOpen(subject) {
		notifyObservers(subject);
	}
	protected pointcut flowerClose(Subject subject):
		execution(void close()) && this(subject);
	after(Subject subject): flowerClose(subject) {
		subject.alreadyOpen = false;
	}

	declare parents: Flower implements Subject;
	declare parents: (Bee || Hummingbird) implements Observer;
}