package observer;

import java.util.Observable;
//import java.util.Observer;

public aspect ObservingClose extends ObserverProtocol {
	declare parents: Flower implements Subject;
	declare parents: (Bee || Hummingbird) implements Observer;

	protected void updateObserver(Subject s, Observer o) { }

	private interface BedtimeSleeper {
		public void bedtimeSleep();
	}
	declare parents: (Bee || Hummingbird) implements BedtimeSleeper;

	static class CloseNotifier extends Observable {
		private Flower _enclosing;
		private boolean alreadyClosed = false;
		public CloseNotifier(Flower flower) {
			_enclosing = flower;
		}
		public void notifyObservers() {
			if(!_enclosing.isOpen() && !this.alreadyClosed) {
				this.setChanged();
				super.notifyObservers();
				this.alreadyClosed = true;
			}
		}
		public void open() {
			this.alreadyClosed = false;
		}
	}
	static class CloseObserver implements java.util.Observer {
		private BedtimeSleeper _enclosing;
		public CloseObserver(BedtimeSleeper enclosing) {
			_enclosing = enclosing;
		}
		public void update(Observable ob, Object a) {
			_enclosing.bedtimeSleep();
		}
	}
	private CloseNotifier Flower.cNotify = new CloseNotifier(this);
	private CloseObserver Bee.closeObsrv = new CloseObserver(this);
	private CloseObserver Hummingbird.closeObsrv = new CloseObserver(this);

	public Observable Flower.closing() {
		return cNotify;
	}
	pointcut flowerOpen(Flower flower):
		execution(void open()) && this(flower);
	after(Flower flower) returning : flowerOpen(flower) {
		flower.cNotify.open();
	}
	protected pointcut subjectChange(Subject /*Flower*/ subject):
		execution(void Subject+.close()) && this(subject);
	after(Subject /*Flower*/ subject): subjectChange(subject) {
		((Flower)subject).cNotify.notifyObservers();
	}

	public java.util.Observer Bee.closeObserver() { 
		return closeObsrv;
	}
	public java.util.Observer Hummingbird.closeObserver() { 
		return closeObsrv;
	}
}
