package observer;

import java.util.Iterator;

public aspect ObservingClose extends ObserverProtocol {
	declare parents: Flower implements Subject;
	declare parents: (Bee || Hummingbird) implements Observer;

	public abstract void Observer.bedtimeSleep();
	private boolean Subject.alreadyClosed = false;

	protected pointcut subjectChange(Subject subject):
		execution(void Subject+.close()) && this(subject);
	after(Subject subject): subjectChange(subject) {
		Flower f = (Flower)subject;
		if(!f.isOpen() && !f.alreadyClosed) {
			Iterator iter = getObservers(subject).iterator();
			while ( iter.hasNext() ) {
				updateObserver(subject, ((Observer)iter.next()));
			}
		}
	}
	pointcut flowerOpen(Subject flower):
		execution(void open()) && this(flower);
	after(Subject subject) returning : flowerOpen(subject) {
		if (subject instanceof Flower) {
			((Flower)subject).alreadyClosed = false;
		}
	}
	protected void updateObserver(Subject s, Observer o) {
		o.bedtimeSleep();
		((Flower)s).alreadyClosed = true;
	}

	after(Subject subject): subjectChange(subject) {
		((Flower)subject).cNotify.notifyObservers();
	}
	after(Subject flower) returning : flowerOpen(flower) {
		flower.cNotify.open();
	}

	public abstract boolean Subject.isOpen();	
	static class CloseNotifier extends java.util.Observable {
		private Subject _enclosing;
		private boolean alreadyClosed = false;
		public CloseNotifier(Subject flower) {
			_enclosing = flower;
		}
		public void notifyObservers() {
			if(!_enclosing.isOpen() && !this.alreadyClosed) {
				this.setChanged();
				super.notifyObservers();
				this.alreadyClosed = true;
			}
		}
		public void open() {
			this.alreadyClosed = false;
		}
	}
	static class CloseObserver implements java.util.Observer {
		private Observer _enclosing;
		public CloseObserver(Observer enclosing) {
			_enclosing = enclosing;
		}
		public void update(java.util.Observable ob, Object a) {
			_enclosing.bedtimeSleep();
		}
	}
	private CloseNotifier Subject.cNotify = new CloseNotifier(this);
	private CloseObserver Observer.closeObsrv = new CloseObserver(this);

	public java.util.Observable Subject.closing() {
		return cNotify;
	}
	public java.util.Observer Observer.closeObserver() { 
		return closeObsrv;
	}
}
